(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import ZArith.
Require Import Rbase.
Require int.Int.
Require real.Real.
Definition unit  := unit.

Parameter qtmark : Type.

Parameter at1: forall (a:Type), a -> qtmark -> a.

Implicit Arguments at1.

Parameter old: forall (a:Type), a -> a.

Implicit Arguments old.

Definition implb(x:bool) (y:bool): bool := match (x,
  y) with
  | (true, false) => false
  | (_, _) => true
  end.

Parameter map : forall (a:Type) (b:Type), Type.

Parameter get: forall (a:Type) (b:Type), (map a b) -> a -> b.

Implicit Arguments get.

Parameter set: forall (a:Type) (b:Type), (map a b) -> a -> b -> (map a b).

Implicit Arguments set.

Axiom Select_eq : forall (a:Type) (b:Type), forall (m:(map a b)),
  forall (a1:a) (a2:a), forall (b1:b), (a1 = a2) -> ((get (set m a1 b1)
  a2) = b1).

Axiom Select_neq : forall (a:Type) (b:Type), forall (m:(map a b)),
  forall (a1:a) (a2:a), forall (b1:b), (~ (a1 = a2)) -> ((get (set m a1 b1)
  a2) = (get m a2)).

Parameter const: forall (b:Type) (a:Type), b -> (map a b).

Set Contextual Implicit.
Implicit Arguments const.
Unset Contextual Implicit.

Axiom Const : forall (b:Type) (a:Type), forall (b1:b) (a1:a),
  ((get (const b1:(map a b)) a1) = b1).

Inductive ref (a:Type) :=
  | mk_ref : a -> ref a.
Implicit Arguments mk_ref.

Definition contents (a:Type)(u:(ref a)): a :=
  match u with
  | (mk_ref contents1) => contents1
  end.
Implicit Arguments contents.

Definition sorted(a:(map Z R)) (i:Z) (j:Z): Prop := forall (k:Z) (l:Z),
  (((i <= k)%Z /\ (k <= l)%Z) /\ (l <  j)%Z) -> ((get a k) <= (get a l))%R.

(* YOU MAY EDIT THE CONTEXT BELOW *)

(* DO NOT EDIT BELOW *)

Theorem WP_parameter_sort : forall (i:Z), forall (j:Z), forall (a:(map Z R)),
  (i <= j)%Z -> ((i <  j)%Z -> (((i + 1%Z)%Z <= j)%Z -> forall (a1:(map Z
  R)), forall (result:Z), ((((i + 1%Z)%Z <= result)%Z /\ (result <= j)%Z) /\
  ((forall (k:Z), (((i + 1%Z)%Z <= k)%Z /\ (k <  result)%Z) -> ((get a1
  k) <= (get a i))%R) /\ forall (k:Z), ((result <= k)%Z /\ (k <  j)%Z) ->
  ((get a i) <= (get a1 k))%R)) -> forall (a2:(map Z R)), (((get a2
  i) = (get a1 (result - 1%Z)%Z)) /\ (((get a2 (result - 1%Z)%Z) = (get a1
  i)) /\ forall (k:Z), ((~ (k = i)) /\ ~ (k = (result - 1%Z)%Z)) -> ((get a2
  k) = (get a1 k)))) -> ((((0%Z <= (j - i)%Z)%Z /\
  (((result - 1%Z)%Z - i)%Z <  (j - i)%Z)%Z) /\ (i <= (result - 1%Z)%Z)%Z) ->
  forall (a3:(map Z R)), ((sorted a3 i (result - 1%Z)%Z) /\ ((forall (n:Z),
  (n <  i)%Z -> ((get a3 n) = (get a2 n))) /\ forall (n:Z),
  ((result - 1%Z)%Z <= n)%Z -> ((get a3 n) = (get a2 n)))) ->
  ((((0%Z <= (j - i)%Z)%Z /\ ((j - result)%Z <  (j - i)%Z)%Z) /\
  (result <= j)%Z) -> forall (a4:(map Z R)), ((sorted a4 result j) /\
  ((forall (n:Z), (n <  result)%Z -> ((get a4 n) = (get a3 n))) /\
  forall (n:Z), (j <= n)%Z -> ((get a4 n) = (get a3 n)))) -> forall (n:Z),
  (j <= n)%Z -> ((get a4 n) = (get a n)))))).
(* YOU MAY EDIT THE PROOF BELOW *)
intuition.
rewrite H21; auto with zarith; clear a4 H21 H4 H19.
rewrite H17; auto with zarith; clear a3 H17 H13 H14.
rewrite H11; auto with zarith; clear a2 H8 H7 H11.

Qed.
(* DO NOT EDIT BELOW *)


