(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import ZArith.
Require Import Rbase.
Require int.Int.

(* Why3 assumption *)
Definition unit  := unit.

Parameter qtmark : Type.

Parameter at1: forall (a:Type), a -> qtmark -> a.
Implicit Arguments at1.

Parameter old: forall (a:Type), a -> a.
Implicit Arguments old.

(* Why3 assumption *)
Definition implb(x:bool) (y:bool): bool := match (x,
  y) with
  | (true, false) => false
  | (_, _) => true
  end.

(* Why3 assumption *)
Inductive list (a:Type) :=
  | Nil : list a
  | Cons : a -> (list a) -> list a.
Set Contextual Implicit.
Implicit Arguments Nil.
Unset Contextual Implicit.
Implicit Arguments Cons.

(* Why3 assumption *)
Set Implicit Arguments.
Fixpoint infix_plpl (a:Type)(l1:(list a)) (l2:(list a)) {struct l1}: (list
  a) :=
  match l1 with
  | Nil => l2
  | (Cons x1 r1) => (Cons x1 (infix_plpl r1 l2))
  end.
Unset Implicit Arguments.

Axiom Append_assoc : forall (a:Type), forall (l1:(list a)) (l2:(list a))
  (l3:(list a)), ((infix_plpl l1 (infix_plpl l2
  l3)) = (infix_plpl (infix_plpl l1 l2) l3)).

Axiom Append_l_nil : forall (a:Type), forall (l:(list a)), ((infix_plpl l
  (Nil :(list a))) = l).

(* Why3 assumption *)
Set Implicit Arguments.
Fixpoint length (a:Type)(l:(list a)) {struct l}: Z :=
  match l with
  | Nil => 0%Z
  | (Cons _ r) => (1%Z + (length r))%Z
  end.
Unset Implicit Arguments.

Axiom Length_nonnegative : forall (a:Type), forall (l:(list a)),
  (0%Z <= (length l))%Z.

Axiom Length_nil : forall (a:Type), forall (l:(list a)),
  ((length l) = 0%Z) <-> (l = (Nil :(list a))).

Axiom Append_length : forall (a:Type), forall (l1:(list a)) (l2:(list a)),
  ((length (infix_plpl l1 l2)) = ((length l1) + (length l2))%Z).

(* Why3 assumption *)
Set Implicit Arguments.
Fixpoint mem (a:Type)(x:a) (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => False
  | (Cons y r) => (x = y) \/ (mem x r)
  end.
Unset Implicit Arguments.

Axiom mem_append : forall (a:Type), forall (x:a) (l1:(list a)) (l2:(list a)),
  (mem x (infix_plpl l1 l2)) <-> ((mem x l1) \/ (mem x l2)).

Axiom mem_decomp : forall (a:Type), forall (x:a) (l:(list a)), (mem x l) ->
  exists l1:(list a), exists l2:(list a), (l = (infix_plpl l1 (Cons x l2))).

Parameter map : forall (a:Type) (b:Type), Type.

Parameter get: forall (a:Type) (b:Type), (map a b) -> a -> b.
Implicit Arguments get.

Parameter set: forall (a:Type) (b:Type), (map a b) -> a -> b -> (map a b).
Implicit Arguments set.

Axiom Select_eq : forall (a:Type) (b:Type), forall (m:(map a b)),
  forall (a1:a) (a2:a), forall (b1:b), (a1 = a2) -> ((get (set m a1 b1)
  a2) = b1).

Axiom Select_neq : forall (a:Type) (b:Type), forall (m:(map a b)),
  forall (a1:a) (a2:a), forall (b1:b), (~ (a1 = a2)) -> ((get (set m a1 b1)
  a2) = (get m a2)).

Parameter const: forall (b:Type) (a:Type), b -> (map a b).
Set Contextual Implicit.
Implicit Arguments const.
Unset Contextual Implicit.

Axiom Const : forall (b:Type) (a:Type), forall (b1:b) (a1:a),
  ((get (const b1:(map a b)) a1) = b1).

(* Why3 assumption *)
Inductive array (a:Type) :=
  | mk_array : Z -> (map Z a) -> array a.
Implicit Arguments mk_array.

(* Why3 assumption *)
Definition elts (a:Type)(v:(array a)): (map Z a) :=
  match v with
  | (mk_array x x1) => x1
  end.
Implicit Arguments elts.

(* Why3 assumption *)
Definition length1 (a:Type)(v:(array a)): Z :=
  match v with
  | (mk_array x x1) => x
  end.
Implicit Arguments length1.

(* Why3 assumption *)
Definition get1 (a:Type)(a1:(array a)) (i:Z): a := (get (elts a1) i).
Implicit Arguments get1.

(* Why3 assumption *)
Definition set1 (a:Type)(a1:(array a)) (i:Z) (v:a): (array a) :=
  (mk_array (length1 a1) (set (elts a1) i v)).
Implicit Arguments set1.

(* Why3 assumption *)
Inductive buffer (a:Type) :=
  | mk_buffer : Z -> Z -> (array a) -> buffer a.
Implicit Arguments mk_buffer.

(* Why3 assumption *)
Definition data (a:Type)(v:(buffer a)): (array a) :=
  match v with
  | (mk_buffer x x1 x2) => x2
  end.
Implicit Arguments data.

(* Why3 assumption *)
Definition len (a:Type)(v:(buffer a)): Z :=
  match v with
  | (mk_buffer x x1 x2) => x1
  end.
Implicit Arguments len.

(* Why3 assumption *)
Definition first (a:Type)(v:(buffer a)): Z :=
  match v with
  | (mk_buffer x x1 x2) => x
  end.
Implicit Arguments first.

(* Why3 assumption *)
Definition size (a:Type)(b:(buffer a)): Z := (length1 (data b)).
Implicit Arguments size.

(* Why3 assumption *)
Definition buffer_invariant (a:Type)(b:(buffer a)): Prop :=
  ((0%Z <= (first b))%Z /\ ((first b) <  (size b))%Z) /\
  ((0%Z <= (len b))%Z /\ ((len b) <= (size b))%Z).
Implicit Arguments buffer_invariant.

Parameter sequence: forall (a:Type), (buffer a) -> (list a).
Implicit Arguments sequence.

Axiom sequence_def_1 : forall (a:Type), forall (b:(buffer a)),
  (buffer_invariant b) -> (((len b) = 0%Z) -> ((sequence b) = (Nil :(list
  a)))).

Axiom sequence_def_2 : forall (a:Type), forall (b:(buffer a)),
  (buffer_invariant b) -> ((0%Z <  (len b))%Z ->
  ((((first b) + 1%Z)%Z <  (size b))%Z ->
  ((sequence b) = (Cons (get1 (data b) (first b))
  (sequence (mk_buffer ((first b) + 1%Z)%Z ((len b) - 1%Z)%Z (data b))))))).

Axiom sequence_def_3 : forall (a:Type), forall (b:(buffer a)),
  (buffer_invariant b) -> ((0%Z <  (len b))%Z ->
  ((((first b) + 1%Z)%Z = (size b)) -> ((sequence b) = (Cons (get1 (data b)
  (first b)) (sequence (mk_buffer 0%Z ((len b) - 1%Z)%Z (data b))))))).

Axiom sequence_ind_1 : forall (a:Type), forall (b:(buffer a)),
  (buffer_invariant b) -> ((0%Z <  (len b))%Z ->
  (((((first b) + (len b))%Z - 1%Z)%Z <  (size b))%Z ->
  ((sequence b) = (infix_plpl (sequence (mk_buffer (first b)
  ((len b) - 1%Z)%Z (data b))) (Cons (get1 (data b)
  (((first b) + (len b))%Z - 1%Z)%Z) (Nil :(list a))))))).

Axiom sequence_ind_2 : forall (a:Type), forall (b:(buffer a)),
  (buffer_invariant b) -> ((0%Z <  (len b))%Z ->
  (((size b) <= (((first b) + (len b))%Z - 1%Z)%Z)%Z ->
  ((sequence b) = (infix_plpl (sequence (mk_buffer (first b)
  ((len b) - 1%Z)%Z (data b))) (Cons (get1 (data b)
  ((((first b) + (len b))%Z - 1%Z)%Z - (size b))%Z) (Nil :(list a))))))).

Axiom sequence_invariance : forall (a:Type), forall (b1:(buffer a))
  (b2:(buffer a)), (buffer_invariant b1) -> ((buffer_invariant b2) ->
  (((first b1) = (first b2)) -> (((len b1) = (len b2)) ->
  (((size b1) = (size b2)) -> ((forall (i:Z), (((first b1) <= i)%Z /\
  (i <  ((first b1) + (len b1))%Z)%Z) -> ((i <  (size b1))%Z ->
  ((get1 (data b1) i) = (get1 (data b2) i)))) -> ((forall (i:Z),
  ((0%Z <= i)%Z /\ (i <  (((first b1) + (len b1))%Z - (size b1))%Z)%Z) ->
  ((get1 (data b1) i) = (get1 (data b2) i))) ->
  ((sequence b1) = (sequence b2)))))))).



(* Why3 goal *)
Theorem WP_parameter_harness : (0%Z <  10%Z)%Z -> forall (result:Z)
  (result1:Z) (result2:Z) (result3:(map Z Z)), let result4 :=
  (mk_buffer result result1 (mk_array result2 result3)) in
  (((buffer_invariant result4) /\ ((result2 = 10%Z) /\
  ((sequence result4) = (Nil :(list Z))))) -> (((result1 <  result2)%Z /\
  (buffer_invariant result4)) -> forall (fresh:(map Z Z)), forall (fresh1:Z),
  let b := (mk_buffer result fresh1 (mk_array result2 fresh)) in
  (((buffer_invariant b) /\ ((fresh1 = (result1 + 1%Z)%Z) /\
  ((sequence b) = (infix_plpl (sequence result4) (Cons 1%Z (Nil :(list
  Z))))))) -> (((fresh1 <  result2)%Z /\ (buffer_invariant b)) ->
  forall (fresh2:(map Z Z)), forall (fresh3:Z), let b1 := (mk_buffer result
  fresh3 (mk_array result2 fresh2)) in (((buffer_invariant b1) /\
  ((fresh3 = (fresh1 + 1%Z)%Z) /\ ((sequence b1) = (infix_plpl (sequence b)
  (Cons 2%Z (Nil :(list Z))))))) -> (((fresh3 <  result2)%Z /\
  (buffer_invariant b1)) -> forall (fresh4:(map Z Z)), forall (fresh5:Z),
  let b2 := (mk_buffer result fresh5 (mk_array result2 fresh4)) in
  (((buffer_invariant b2) /\ ((fresh5 = (fresh3 + 1%Z)%Z) /\
  ((sequence b2) = (infix_plpl (sequence b1) (Cons 3%Z (Nil :(list
  Z))))))) -> (((0%Z <  fresh5)%Z /\ (buffer_invariant b2)) ->
  forall (fresh6:Z), forall (fresh7:Z), let b3 := (mk_buffer fresh7 fresh6
  (mk_array result2 fresh4)) in forall (result5:Z), ((buffer_invariant b3) /\
  ((fresh6 = (fresh5 - 1%Z)%Z) /\
  match (sequence b2) with
  | Nil => False
  | (Cons x l) => (result5 = x) /\ ((sequence b3) = l)
  end)) -> ((result5 = 1%Z) -> (((0%Z <  fresh6)%Z /\
  (buffer_invariant b3)) -> forall (fresh8:Z), forall (fresh9:Z), let b4 :=
  (mk_buffer fresh9 fresh8 (mk_array result2 fresh4)) in forall (result6:Z),
  ((buffer_invariant b4) /\ ((fresh8 = (fresh6 - 1%Z)%Z) /\
  match (sequence b3) with
  | Nil => False
  | (Cons x l) => (result6 = x) /\ ((sequence b4) = l)
  end)) -> (result6 = 2%Z))))))))))).
(* YOU MAY EDIT THE PROOF BELOW *)
intuition.
intuition.
subst.
clear H2 H4 H7 H9 H12 H14 H17 H19 H23 H25 H27.
rewrite H5 in *; clear H5.
rewrite H10 in *; clear H10.
rewrite H15 in *; clear H15.
rewrite H20 in *; clear H20.
simpl in H26.
destruct H26.
rewrite H2 in *; clear H2.
intuition.
Qed.


